<template>
    <div class="app-container calendar-list-container">

        <!-- 查询和其他操作 -->
        <div class="filter-container">
            <el-input clearable class="filter-item" style="width: 200px;" placeholder="商品名称"
                v-model="listQuery.name"></el-input>
            <el-input clearable class="filter-item" style="width: 200px;" placeholder="商品编号"
                v-model="listQuery.seq"></el-input>
            <el-select v-model="listQuery.status" clearable placeholder="状态" class="filter-item" style="width: 200px;">
                <el-option :key="item.type" v-for="item in goodsStatusList" :label="item.name" :value="item.type">
                </el-option>
            </el-select>
            <el-select v-model="listQuery.productAttribute" clearable placeholder="商品属性" class="filter-item" style="width: 200px">
                        <el-option :key="item.dictValue" v-for="item in productAttributeList" :label="item.dictLabel"
                            :value="item.dictValue">
                        </el-option>
                    </el-select>
            <el-button class="filter-item" type="primary" v-waves icon="el-icon-search" @click="handleFilter">查找</el-button>
            <el-button class="filter-item" type="primary" @click="handleCreate" icon="el-icon-edit">添加</el-button>

        </div>

        <!-- 查询结果 -->
        <el-table size="small" :data="list" v-loading="listLoading" element-loading-text="正在查询中。。。" border fit
            highlight-current-row>
            <el-table-column type="index" label="序号" header-align="center" align="center">
            </el-table-column>

            <el-table-column align="center" min-width="200px" label="商品名称" prop="name">
            </el-table-column>

            <el-table-column align="center" min-width="120px" label="商品编号" prop="seq">
            </el-table-column>

            <el-table-column align="center" min-width="80px" label="商品属性" prop="productAttributeName">
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="积分" prop="price">
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="参考价格" prop="hisPrice">
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="折扣比例" prop="discountRatio">
            </el-table-column>
            <el-table-column align="center" min-width="100px" label="库存量" prop="actualStock">
            </el-table-column>
            <el-table-column align="center" min-width="100px" label="可兑换库存量" prop="stock">
            </el-table-column>
            <!-- <el-table-column align="center" min-width="100px" label="商品所在地" prop="location">
            </el-table-column> -->
            <el-table-column align="center" min-width="80px" label="商品状态">
                <template slot-scope="props">
                    <span v-if="props.row.status == 1">上架</span>
                    <span v-if="props.row.status == 0">下架</span>
                </template>
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="兑换记录">
                <template slot-scope="props">
                    <span @click="handleView(props.row)" style="color:green;cursor: pointer;">查看</span>
                </template>
            </el-table-column>
            <!-- fixed="right" -->
            <el-table-column align="center" label="操作" width="240px" class-name="small-padding fixed-width">
                <template slot-scope="scope">
                    <el-button type="primary" size="small" @click="handleUpdate(scope.row)">编辑</el-button>
                    <el-button v-if="scope.row.status == 0" type="success" size="small"
                        @click="changeGoodsState(scope.row.skuId, 1)">上架</el-button>
                    <el-button v-if="scope.row.status == 1" type="warning" size="small"
                        @click="changeGoodsState(scope.row.skuId, 0)">下架</el-button>
                    <el-button type="danger" size="small" @click="handleDelete(scope.row.skuId, -1)">删除</el-button>
                </template>
            </el-table-column>
        </el-table>

        <!-- 分页 -->
        <div class="pagination-container">
            <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
                :current-page="listQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="listQuery.limit"
                layout="total, sizes, prev, pager, next, jumper" :total="total">
            </el-pagination>
        </div>

        <!-- 员工积分记录列表 -->
        <el-dialog :close-on-click-modal="false" title="兑换记录" :visible.sync="dialogListVisible" width="70%" style="overflow: auto;">
            <div class="filter-container">
                <el-select filterable v-model="itemListQuery.deptId" clearable placeholder="部门" style="top: -4px;width: 200px;">
                    <el-option :key="item.deptId" v-for="item in depTypeList" :label="item.deptName" :value="item.deptId">
                    </el-option>
                </el-select>
                <el-input clearable class="filter-item" style="width: 200px;" placeholder="员工名称"
                    v-model="itemListQuery.userName"></el-input>
                <el-button class="filter-item" type="primary" v-waves icon="el-icon-search"
                    @click="itemHandleFilter">查找</el-button>
                <el-button class="filter-item" type="primary" @click="handleDownLoad" v-waves icon="el-icon-download">导出</el-button>

            </div>
            <!-- 查询结果 -->
            <el-table size="small" :data="itemList" v-loading="listLoading" element-loading-text="正在查询中。。。" border fit
            highlight-current-row>
            <el-table-column type="index" label="序号" header-align="center" align="center">
                </el-table-column>
                <el-table-column align="center" width="200px" label="部门" prop="deptName">
                </el-table-column>
                <el-table-column align="center" label="员工姓名" prop="purchaser">
                </el-table-column>
                <el-table-column align="center" label="兑换数量" prop="skuCount">
                </el-table-column>
                <el-table-column align="center" label="联系人" prop="contact">
                </el-table-column>
                <el-table-column align="center" width="120px" label="联系方式" prop="contactPhone">
                </el-table-column>
                <el-table-column align="center" width="200px" label="地址" prop="contactAddr">
                </el-table-column>
                <!-- <el-table-column align="center" width="200px" label="邮箱" prop="contactEmail">
                </el-table-column> -->
                <el-table-column align="center" width="150px" label="兑换时间" prop="createTime">
                </el-table-column>
        </el-table>
            <!-- 分页 -->
            <div class="pagination-container">
                <el-pagination background @size-change="itemHandleSizeChange" @current-change="itemHandleCurrentChange"
                    :current-page="itemListQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="itemListQuery.limit"
                    layout="total, sizes, prev, pager, next, jumper" :total="itemTotal">
                </el-pagination>
            </div>
        </el-dialog>
        <!-- 添加或修改对话框 -->
        <el-dialog :close-on-click-modal="false" :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible" width="70%">
            <el-form :rules="rules" ref="dataForm" :model="dataForm" status-icon label-position="left" label-width="100px" style='width:700px; margin-left:50px;'>
                <el-form-item label="商品编号" prop="seq">
                    <el-input disabled placeholder="添加成功后自动生成" readonly v-model="dataForm.seq"></el-input>
                </el-form-item>
                <el-form-item label="商品简介" prop="brief">
                    <el-input v-model="dataForm.brief"></el-input>
                </el-form-item>
                <el-form-item label="商品名称" prop="name">
                    <el-input v-model="dataForm.name"></el-input>
                </el-form-item>

                

                <el-form-item label="商品属性" prop="productAttribute">
                    <el-select v-model="dataForm.productAttribute" filterable placeholder="请选择" style="width: 350px"
                        value-key="value" @change="changeProductAttribute">
                        <el-option :key="item.dictValue" v-for="item in productAttributeList" :label="item.dictLabel"
                            :value="item.dictValue">
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="兑换方式" prop="deliveryTypes">
                    <el-select v-model="dataForm.deliveryTypes" multiple filterable placeholder="请选择" style="width: 350px">
                        <el-option :key="item.dictValue" v-for="item in deliveryTypeList" :label="item.dictLabel" :value="item.dictValue">
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item v-if="dataForm.deliveryTypes.includes('1')" label="快递方式">
                    <el-radio-group v-model="dataForm.freightType">
                        <el-radio :label="'0'">不包邮</el-radio>
                        <el-radio :label="'1'">包邮</el-radio>
                    </el-radio-group>
                </el-form-item>
                <!-- <el-form-item v-if="dataForm.deliveryTypes==0" label="商品所在地" prop="location">
                    <el-select v-model="dataForm.location" filterable placeholder="请选择" style="width: 350px">
                        <el-option :key="item.dictLabel" v-for="item in locationList" :label="item.dictLabel" :value="item.dictLabel">
                        </el-option>
                    </el-select>
                </el-form-item> -->
                <el-form-item style="width: 800px" label="商品图片" prop="imgUrl">
                    <el-upload :limit="1" :action="fileImgUrl" list-type="picture-card" :file-list="dataForm.images"
                            :on-success="handleGallerySucess" :on-exceed="handleExceed" :before-upload="uploadBannerImg"
                            :on-remove="handleRemove">
                            <i class="el-icon-plus"></i>
                        </el-upload>
                </el-form-item>
                <el-form-item label="积分" prop="price">
                    <el-input v-model="dataForm.price"></el-input>
                </el-form-item>
                <el-form-item label="参考价格" prop="hisPrice">
                    <el-input v-model="dataForm.hisPrice"></el-input>
                </el-form-item>
                <el-form-item label="折扣比例" prop="discountRatio">
                    <el-input-number v-model="dataForm.discountRatio" :precision="2" :step="0.01" :min="0" :max="1"></el-input-number>
                </el-form-item>
                <el-form-item label="库存量" prop="actualStock">
                    <el-input-number :precision="0" :step="1" v-model="dataForm.actualStock"></el-input-number>
                </el-form-item>
                <el-form-item
                    style="width: 800px"
                    label="兑换说明"
                    prop="comment"
                    >
                <tinymce v-model="dataForm.comment" ref="tinymce"></tinymce>
                </el-form-item>
                <el-form-item style="width: 800px" label="商品副图">
                    <el-upload :action="fileImgUrl" list-type="picture-card" :file-list="dataForm.imgUrls"
                            :on-success="handleAvatarSuccess"
                            :on-remove="handleRemoveImgs">
                            <i class="el-icon-plus"></i>
                        </el-upload>
                </el-form-item>
                <el-form-item
                    style="width: 800px"
                    label="物品介绍"
                    prop="skuDesc"
                    >
                <skuDesc v-model="dataForm.skuDesc" ref="skuDesc"></skuDesc>
                </el-form-item>
            </el-form>
            <div slot="footer" class="dialog-footer">
                <el-button @click="dialogFormVisible = false">取消</el-button>
                <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
                <el-button v-else type="primary" @click="updateData">确定</el-button>
            </div>
        </el-dialog>

    </div>
</template>
  
<style>
.demo-table-expand {
    font-size: 0;
}

.demo-table-expand label {
    width: 200px;
    color: #99a9bf;
}

.demo-table-expand .el-form-item {
    margin-right: 0;
    margin-bottom: 0;
}
</style>
  
<script>
import { createItem, updateItem, goodsList, goodsState, exchangeHistory } from "@/api/goodsManage";
import { depTypeList,dataTypeList } from "@/api/public";
import waves from "@/directive/waves"; // 水波纹指令
import Tinymce from '@/components/Tinymce';
import SkuDesc from '@/components/SkuDesc'

export default {
    name: 'goodsList',
    components: { Tinymce,SkuDesc },
    directives: { waves },
    data() {
        return {
            locationList:[],
            productAttributeList: [],
            deliveryTypeList: [],
            goodsStatusList: [
                {
                    type: 1,
                    name: '上架'
                },
                {
                    type: 0,
                    name: '下架'
                },
            ],
            depTypeList: [],
            list: [],
            itemList: [],
            total: 0,
            itemTotal: 0,
            listLoading: false,
            downloadLoading: false,
            listQuery: {
                skuType:0,
                page: 1,
                limit: 10,
                name: '',
                seq: '',
                status: '',
                productAttribute:'',
            },
            itemListQuery: {
                skuType:0,
                page: 1,
                limit: 10,
                skuId:'',
                deptId: '',
                userName: '',
            },
            dataForm: {
                skuType:0,
                brief: undefined,
                name: undefined,
                seq: undefined,
                productAttribute: undefined,
                imgUrl: undefined,
                price: undefined,
                hisPrice:undefined,
                discountRatio:1,
                actualStock: undefined,
                deliveryTypes: [],
                freightType:'0',
                // location: undefined,
                images: [],
                imgIds: '',
                imgUrls:[],
            },
            dialogFormVisible: false,
            dialogStatus: '',
            textMap: {
                update: "编辑",
                create: "创建",
            },
            rules: {
                brief: [{ required: true, message: "请填写商品简介", trigger: "blur" }],
                name: [{ required: true, message: "请填写商品名称", trigger: "blur" }],
                imgUrl: [{ required: true, message: "请上传商品图片", trigger: "blur" }],
                imgIds: [{ required: true, message: "请上传商品副图", trigger: "blur" }],
                productAttribute: [{ required: true, message: "请选择商品属性", trigger: "blur" }],
                price: [{ required: true, message: "请填写商品积分", trigger: "blur" }],
                hisPrice: [{ required: true, message: "请填写商品参考价格", trigger: "blur" }],
                actualStock: [{ required: true, message: "请设置库存量", trigger: "blur" }],
                deliveryTypes: [{ required: true, message: "请选择兑换方式", trigger: "blur" }],
                // location: [{ required: true, message: "请选择商品所在地", trigger: "blur" }],
                comment: [{ required: true, message: "说明不能为空", trigger: "blur" }],
                skuDesc: [{ required: true, message: "商品介绍不能为空", trigger: "blur" }],
            },
            dialogListVisible: false,
            fileImgUrl: this.upLoadUrl,
        }
    },
    created() {
        this.getProductAttributeList();
        this.getDataTypeList(); 
        this.getDepTypeList(); 
        this.getList();
    },
    methods: {
        getDeliveryTypeList(val){
            dataTypeList({dictType:val}).then(response => {
                this.deliveryTypeList = response.data.data;
            });
        },
        handleDownLoad(){
            window.location.href = process.env.BASE_API + '/mall-sku/exportSkuLog?skuId=' + this.itemListQuery.skuId + '&deptId=' + this.itemListQuery.deptId + '&userName=' + this.itemListQuery.userName;
        },
        changeProductAttribute(val) {
            debugger
            this.dataForm.deliveryTypes = [];
            // this.dataForm.location = undefined;
            this.getDeliveryTypeList(val);
        },
        handleRemove(file, fileList) {
            console.log(file, fileList);
            let images = [];
            for (let i in fileList) {
                let response = fileList[i].response;
                let url = response.data.url;
                images.push(url);
                this.dataForm.imgUrl = images.join(",");
            }
        },
        handleAvatarSuccess(res, file, fileList) {
            console.log(file, fileList);
            console.log("------", "==========");
            console.log("res = ", res);

            let fileIds = [];
            for (let i in fileList) {
                let response = fileList[i].response;
                if (response.errno && response.errno != "0") {
                this.$message.error("该文件上传失败,已被移除,请重新上传!");
                // 上传失败移除该 file 对象
                fileList.splice(i, 1);
                } else {
                let id = fileList[i].response.data.id;
                fileIds.push(id);
                }
            }
            this.dataForm.imgIds = fileIds.join(",");
        },
        handleRemoveImgs(file, fileList) {
            console.log(file, fileList);
            let fileIds = [];
            for (let i in fileList) {
                let id = fileList[i].response.data.id;
                fileIds.push(id);
            }
            this.dataForm.imgIds = fileIds.join(",");
        },
        uploadBannerImg(file) {
            const isJPGs = file.type === "image/jpeg";
            console.log(isJPGs);
        },
        handleExceed(files, fileList) {
            this.$message.warning(
                `当前限制选择 1 个文件，本次选择了 ${files.length} 个文件！，共选择了 ${files.length + fileList.length
                } 个文件`
            );
        },
        handleGallerySucess(res, file, fileList) {
            this.dataForm.imgUrl = ""; // 清空画廊图片数组

            let images = [];
            for (let i in fileList) {
                let response = fileList[i].response;
                if (response.errno && response.errno != "0") {
                    this.$message.error("该图片上传失败,已被移除,请重新上传!");
                    // 上传失败移除该 file 对象
                    fileList.splice(i, 1);
                } else {
                    let url = response.data.url;
                    images.push(url);
                }
            }

            this.dataForm.imgUrl = images.join(",");
        },
        resetForm() {
            this.dataForm = {
                skuType:0,
                comment: undefined,
                skuDesc: undefined,
                brief: undefined,
                name: undefined,
                seq: undefined,
                productAttribute: undefined,
                imgUrl: undefined,
                price: undefined,
                hisPrice:undefined,
                discountRatio:1,
                actualStock: undefined,
                deliveryTypes: [],
                freightType:'0',
                // location: undefined,
                images: [],
                imgIds: '',
                imgUrls:[],
            };
        },
        handleCreate() {
            this.resetForm();

            this.dialogFormVisible = true;
            this.dialogStatus = "create";

            this.$nextTick(() => {
                this.$refs.tinymce.setContent("");
                this.$refs.skuDesc.setContent("");
                this.$refs["dataForm"].clearValidate();
            });
        },
        createData() {
            
            this.$refs["dataForm"].validate((valid) => {
                if (valid) {
                    console.log(this.dataForm);
                    createItem(this.dataForm)
                            .then((response) => {
                                this.getList();
                                this.dialogFormVisible = false;
                                this.$notify({
                                    title: "成功",
                                    message: "创建成功",
                                    type: "success",
                                    duration: 2000,
                                });
                                this.reload();
                            })
                            .catch(() => { });
                }
            });
        },
        handleUpdate(row) {
            this.dataForm = Object.assign({}, row);
            this.dataForm.productAttribute = row.productAttribute.toString();
            let comment = this.dataForm.comment;
            let skuDesc = this.dataForm.skuDesc?this.dataForm.skuDesc:'';
            let val = row.productAttribute;
            this.getDeliveryTypeList(val);
            if (this.dataForm.imgUrl) {
                let images = this.dataForm.imgUrl.split(",");
                this.dataForm.images = [];
                for (let i in images) {
                    let url = images[i];
                    let name = "image_" + i;

                    this.dataForm.images.push({
                        name: name,
                        url: url,
                        response: { error: "0", data: { url: url } },
                    });
                }
            }
            if (this.dataForm.imgs) {
                let imgs = this.dataForm.imgs;
                this.dataForm.imgUrls = [];
                for (let i in imgs) {
                    let url = imgs[i].url;
                    let name = "image_" + i;

                    this.dataForm.imgUrls.push({
                        name: name,
                        url: url,
                        response: { error: "0", data: imgs[i] },
                    });
                }
            }
            this.dialogStatus = 'update'
            this.dialogFormVisible = true
            this.$nextTick(() => {
                this.$refs.tinymce.setContent(comment);
                this.$refs.skuDesc.setContent(skuDesc);
                this.$refs['dataForm'].clearValidate()
            })
        },
        updateData() {
            this.$refs['dataForm'].validate((valid) => {
                if (valid) {
                    updateItem(this.dataForm).then(() => {
                            this.dialogFormVisible = false
                            this.$notify({
                                title: '成功',
                                message: '更新成功',
                                type: 'success',
                                duration: 2000
                            })
                            this.getList()
                        })

                }

            })
        },
        changeGoodsState(id, index) {
            goodsState({ skuType:0,skuId: id, status: index }).then(response => {
                this.$notify({
                    title: '成功',
                    message: '商品状态修改成功',
                    type: 'success',
                    duration: 2000
                })
                this.getList()
            })
        },
        handleDelete(id, index) {
            this.$confirm('确认删除吗?', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
            }).then(() => {
                goodsState({skuType:0, skuId: id, status: index }).then(response => {
                    this.$notify({
                        title: '成功',
                        message: '删除成功',
                        type: 'success',
                        duration: 2000
                    })
                    this.getList();
                })
            }).catch(() => {

            })

        },
        getDataTypeList() {
            dataTypeList({dictType:'mall_sku_location'}).then(response => {
                this.locationList = response.data.data;
            }).catch(() => {});
        },
        getProductAttributeList(){
            dataTypeList({dictType:'mall_sku_attribute'}).then(response => {
                this.productAttributeList = response.data.data;
            }).catch(() => {});
        },
        getDepTypeList() {
            depTypeList().then(response => {
                this.depTypeList = response.data.data;
            }).catch(() => {});
        },
        getList() {
            this.listLoading = true
            goodsList(this.listQuery).then(response => {
                this.list = response.data.data.items
                this.total = response.data.data.total
                this.listLoading = false
            }).catch(() => {})
        },
        getItemList() {
            this.listLoading = true
            exchangeHistory(this.itemListQuery).then(response => {
                this.itemList = response.data.data.items
                this.itemLotal = response.data.data.total
                this.listLoading = false
            }).catch(() => {})
        },

        handleFilter() {
            this.listQuery.page = 1
            this.getList()
        },
        handleSizeChange(val) {
            this.listQuery.limit = val
            this.getList()
        },
        handleCurrentChange(val) {
            this.listQuery.page = val
            this.getList()
        },

        itemHandleFilter() {
            this.itemListQuery.page = 1
            this.getItemList()
        },
        itemHandleSizeChange(val) {
            this.itemListQuery.limit = val
            this.getItemList()
        },
        itemHandleCurrentChange(val) {
            this.itemListQuery.page = val
            this.getItemList()
        },

        handleView(row) {
            this.itemListQuery.skuId = row.skuId;
            this.getItemList();
            this.dialogListVisible = true
        },
    }
}
</script>
<style>
.ad-avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
}

.ad-avatar-uploader .el-upload:hover {
    border-color: #409EFF;
}

.ad-avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 178px;
    height: 178px;
    line-height: 178px;
    text-align: center;
}

.ad-avatar {
    display: block;
}
</style>
  